70f72d6930ad0b3a61fb4b0ded49eb711ae9a217
[xfstests-dev.git] / tests / xfs / 044
1 #! /bin/bash
2 # FS QA Test No. 044
3 #
4 # external log uuid/format tests (TODO - version 2 log format)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
8 #-----------------------------------------------------------------------
9 #
10 #-----------------------------------------------------------------------
11 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
12 #
13 # This program is free software; you can redistribute it and/or
14 # modify it under the terms of the GNU General Public License as
15 # published by the Free Software Foundation.
16 #
17 # This program is distributed in the hope that it would be useful,
18 # but WITHOUT ANY WARRANTY; without even the implied warranty of
19 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
20 # GNU General Public License for more details.
21 #
22 # You should have received a copy of the GNU General Public License
23 # along with this program; if not, write the Free Software Foundation,
24 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
25 #
26 #-----------------------------------------------------------------------
27 #
28
29 seq=`basename $0`
30 seqres=$RESULT_DIR/$seq
31 echo "QA output created by $seq"
32
33 here=`pwd`
34 tmp=/tmp/$$
35 status=1        # failure is the default!
36 trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
37
38 # get standard environment, filters and checks
39 . ./common/rc
40 . ./common/filter
41
42 # real QA test starts here
43 _supported_fs xfs
44 _supported_os Linux
45
46 _require_logdev
47
48 _filter_logprint()
49 {
50         perl -ne '
51             s/data device: ([\w|\/.-]+)/data device: DDEV/;
52             s/log device: ([\w|\/.-]+) daddr: (\d+) length: (\d+)/log device: LDEV daddr: XXX length: XXX/;
53             s/log file: "([\w|\/.-]+)" daddr: (\d+) length: (\d+)/log device: LDEV daddr: XXX length: XXX/;
54             s/uuid: ([abcdef\d-]+)\s+format: (.+)/uuid: UUID format: FORMAT/;
55             s/skipped (\w+) zeroed blocks/skipped XXX zeroed blocks/;
56             print;
57         '
58 }
59
60 _check_mount()
61 {
62     echo "    *** mount (expect success)"
63     if ! _try_scratch_mount
64     then
65         echo "        !!! mount failed (expecting success)"
66         status=1
67         exit
68     fi
69
70     echo "    *** umount"
71     if ! _scratch_unmount
72     then
73         echo "        !!! umount failed (expecting success)"
74         status=1
75         exit
76     fi
77 }
78
79 _check_no_mount()
80 {
81     echo "    *** mount (expect failure)"
82     if _try_scratch_mount >$tmp.err 2>&1
83     then
84         cat $tmp.err
85         echo "        !!! mount succeeded (expecting failure)"
86         status=1
87         exit
88     fi
89 }
90
91 _check_require_logdev()
92 {
93     echo "    *** mount without logdev (expect failure)"
94     if mount -t xfs $SCRATCH_DEV $SCRATCH_MNT >$tmp.err 2>&1
95     then
96         cat $tmp.err
97         echo "        !!! mount succeeded (expecting failure)"
98         status=1
99         exit
100     fi
101 }
102
103 _unexpected()
104 {
105     echo "        !!! unexpected XFS command failure"
106     status=1
107     exit
108 }
109
110 # real QA test starts here
111
112 _require_scratch
113
114 echo "*** mkfs"
115
116 # this test only works for version 1 logs currently
117 lversion=1
118 lsize=16777216
119 _scratch_mkfs_xfs -lsize=$lsize,version=$lversion >$tmp.mkfs0 2>&1
120 [ $? -ne 0 ] && \
121     _notrun "Cannot mkfs for this test using MKFS_OPTIONS specified"
122 _filter_mkfs <$tmp.mkfs0 2>$tmp.mkfs1
123 . $tmp.mkfs1
124 [ $lversion -ne 1 ] && \
125     _notrun "Cannot run this test yet using MKFS_OPTIONS specified"
126
127 _require_test_program "loggen"
128
129 _check_mount
130 _check_require_logdev
131
132 echo "*** set uuid"
133 _scratch_xfs_db -x  -l $SCRATCH_LOGDEV -c "uuid 02020202-0202-0202-0202-020202020202"
134 [ $? -ne 0 ] && _unexpected
135 _check_mount
136
137 echo "*** zero log"
138 $here/src/loggen -z 100 >$SCRATCH_LOGDEV
139 _check_mount
140
141 echo "*** write clean log"
142 $here/src/loggen -u 2 -f 1 -m 1 -z 100 >$SCRATCH_LOGDEV
143 _check_mount
144
145 echo "*** write clean log (different format)"
146 $here/src/loggen -u 2 -f 99 -m 1 -z 100 >$SCRATCH_LOGDEV
147 _check_mount
148
149 echo "*** write clean log (different uuid)"
150 $here/src/loggen -u 7 -m 1 -z 100 >$SCRATCH_LOGDEV
151 _check_no_mount
152
153 echo "*** write clean log (different uuid & format)"
154 $here/src/loggen -u 7 -f 99 -m 1 -z 100 >$SCRATCH_LOGDEV
155 _check_no_mount
156
157 echo "*** write dirty log"
158 $here/src/loggen -u 2 -e 1 -z 100 >$SCRATCH_LOGDEV
159 _check_mount
160
161 echo "*** write dirty log (different format)"
162 $here/src/loggen -u 2 -f 99 -e 1 -z 100 >$SCRATCH_LOGDEV
163 _check_no_mount
164
165 echo "*** write dirty log (irix style)"
166 $here/src/loggen -u 0 -f 0 -e 1 -z 100 >$SCRATCH_LOGDEV
167 _check_no_mount
168
169 echo "*** write large dirty log"
170 $here/src/loggen -u 2 -e 16000 -z 100 >$SCRATCH_LOGDEV
171 _check_mount
172
173 echo -e -n "\n\r*** XFS QA 044 - done\n\r\n\r" >/dev/console
174
175 status=0
176 # if error
177 exit